#ifndef MESH_H
#define MESH_H
#include "primitives.h"

typedef struct _mesh {
  Vertex *vertices;
  GLshort *indices;

  long vertexCount;
  long indexCount;
  
  int gridWidth;
  int gridHeight;
} Mesh;

typedef Mesh* MeshRef;

MeshRef MeshCreate(Vertex *vertices, GLshort *indices);

// generates a horizontal grid
MeshRef MeshCreateGrid(int gridWidth, int gridHeight, GLfloat width, GLfloat height, GLfloat y);

void MeshRecomputeNormals(MeshRef self);
void MeshDraw(MeshRef self);

#endif