#include "primitives.h"
#include <stdlib.h>
#include <math.h>

Point PointMake(GLfloat x, GLfloat y, GLfloat z) {
  Point point;

  point.x = x;
  point.y = y;
  point.z = z;
  
  return point;
}

Point PointMakeZero() {
  return PointMake(0.0, 0.0, 0.0);
}


Vector VectorMake(GLfloat u, GLfloat v, GLfloat w) {
  Vector vector;
  
  vector.u = u;
  vector.v = v;
  vector.w = w;
  
  return vector;
}

Vector VectorMakeZero() {
  return VectorMake(0.0, 0.0, 0.0);
}

double VectorLength(Vector v) {  
  return sqrt(fabs(v.u*v.u + v.v*v.v + v.w*v.w));
}

Vector CrossProduct(Vector const v1, Vector const v2) {
  return VectorMake((v1.v * v2.w - v1.w * v2.v), (v1.w * v2.u - v1.u * v2.w), (v1.u * v2.v - v1.v * v2.u));
}

Vertex VertexMake(Point position, Vector normal) {
  Vertex self;
  
  self.position[0] = position.x; self.position[1] = position.y; self.position[2] = position.z;
  self.normal[0] = normal.u; self.normal[1] = normal.v; self.normal[2] = normal.w; 
  
  return self; 
}