#ifndef DRAWING_H
#define DRAWING_H

#include "primitives.h"
#include "mesh.h"

typedef struct _scene {
  MeshRef mesh;
  int width;
  int height;
  Point cameraTarget;
  Point cameraPosition;
  Vector lightDirection;
} Scene;

typedef Scene* SceneRef;

// singleton access
SceneRef MainScene();

// TODO only one scene at a time is supported right now because some commands are passed to OpenGL directly
SceneRef SceneMake();

// for now only one mesh in the scene is supported
void SceneSetMesh(SceneRef self, MeshRef mesh);

void SceneSetLight(SceneRef self, Vector direction);

void SceneSetCamera(SceneRef self, Point cp, Point ct);
void SceneRotateCamera(SceneRef self, Vector axis, GLfloat angle);

void SceneRender(SceneRef self);

void SceneUpdateViewport(SceneRef self, int width, int height);

#endif