#include "input.h"

#include <GL/glut.h>
#include "math.h"
#include "drawing.h"

int mouseLastX; // motion tracking
int mouseLeftDown = 0;

void MouseDragged(int x, int y) {
  if(!mouseLeftDown)
    return;
  
  SceneRef scene = MainScene();
  int h = scene->height;
  
  double dx = (double) (x - mouseLastX) / (double) h;
  double da = dx * 180.0;
  
  SceneRotateCamera(scene, VectorMake(0.0, 1.0, 0.0), da);
  
  mouseLastX = x;
  
  glutPostRedisplay();
}

void MouseButton(int button, int state, int x, int y) {
  if(button == GLUT_LEFT_BUTTON) {
    if(state == GLUT_DOWN) {
      mouseLeftDown = 1;
      mouseLastX = x;
    } else {
      // TODO check for click
      mouseLeftDown = 0;
    }
  }
  
  glutPostRedisplay();
}